import { resolve } from 'path';
import { fileURLToPath } from 'url';
import { defineNuxtModule, addPlugin, addComponent } from '@nuxt/kit';

const module = defineNuxtModule({
  meta: {
    name: "json-editor",
    configKey: "jsoneditor",
    compatibility: {
      nuxt: "^3"
    }
  },
  defaults: {
    componentName: "JsonEditor",
    options: {}
  },
  async setup(opt, nuxt) {
    const runtimeDir = fileURLToPath(new URL("./runtime", import.meta.url));
    nuxt.options.build.transpile.push(runtimeDir);
    nuxt.options.runtimeConfig.public.jsonEditorConfig = opt;
    addPlugin({
      src: resolve(runtimeDir, "plugin")
    });
    await addComponent({
      name: opt.componentName || "JsonEditor",
      filePath: "vue3-ts-jsoneditor"
    });
  }
});

export { module as default };
